/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.antrax.storage.enums.CallType;
import com.flamesgroup.storage.jooq.tables.Cdr;
import com.flamesgroup.unit.PhoneNumber;

import java.util.Date;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record10;
import org.jooq.Row10;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CdrRecord extends UpdatableRecordImpl<CdrRecord> implements Record10<Long, Date, Date, Date, PhoneNumber, String, CallType, Date, Date, PhoneNumber> {

	private static final long serialVersionUID = 1191710947;

	/**
	 * Setter for <code>public.cdr.id</code>.
	 */
	public CdrRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.cdr.setup_time</code>.
	 */
	public CdrRecord setSetupTime(Date value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.setup_time</code>.
	 */
	public Date getSetupTime() {
		return (Date) getValue(1);
	}

	/**
	 * Setter for <code>public.cdr.start_time</code>.
	 */
	public CdrRecord setStartTime(Date value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.start_time</code>.
	 */
	public Date getStartTime() {
		return (Date) getValue(2);
	}

	/**
	 * Setter for <code>public.cdr.stop_time</code>.
	 */
	public CdrRecord setStopTime(Date value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.stop_time</code>.
	 */
	public Date getStopTime() {
		return (Date) getValue(3);
	}

	/**
	 * Setter for <code>public.cdr.called_phone_number</code>.
	 */
	public CdrRecord setCalledPhoneNumber(PhoneNumber value) {
		setValue(4, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.called_phone_number</code>.
	 */
	public PhoneNumber getCalledPhoneNumber() {
		return (PhoneNumber) getValue(4);
	}

	/**
	 * Setter for <code>public.cdr.voice_server_name</code>.
	 */
	public CdrRecord setVoiceServerName(String value) {
		setValue(5, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.voice_server_name</code>.
	 */
	public String getVoiceServerName() {
		return (String) getValue(5);
	}

	/**
	 * Setter for <code>public.cdr.call_type</code>.
	 */
	public CdrRecord setCallType(CallType value) {
		setValue(6, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.call_type</code>.
	 */
	public CallType getCallType() {
		return (CallType) getValue(6);
	}

	/**
	 * Setter for <code>public.cdr.dial_time</code>.
	 */
	public CdrRecord setDialTime(Date value) {
		setValue(7, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.dial_time</code>.
	 */
	public Date getDialTime() {
		return (Date) getValue(7);
	}

	/**
	 * Setter for <code>public.cdr.alert_time</code>.
	 */
	public CdrRecord setAlertTime(Date value) {
		setValue(8, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.alert_time</code>.
	 */
	public Date getAlertTime() {
		return (Date) getValue(8);
	}

	/**
	 * Setter for <code>public.cdr.caller_phone_number</code>.
	 */
	public CdrRecord setCallerPhoneNumber(PhoneNumber value) {
		setValue(9, value);
		return this;
	}

	/**
	 * Getter for <code>public.cdr.caller_phone_number</code>.
	 */
	public PhoneNumber getCallerPhoneNumber() {
		return (PhoneNumber) getValue(9);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record10 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row10<Long, Date, Date, Date, PhoneNumber, String, CallType, Date, Date, PhoneNumber> fieldsRow() {
		return (Row10) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row10<Long, Date, Date, Date, PhoneNumber, String, CallType, Date, Date, PhoneNumber> valuesRow() {
		return (Row10) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return Cdr.CDR.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field2() {
		return Cdr.CDR.SETUP_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field3() {
		return Cdr.CDR.START_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field4() {
		return Cdr.CDR.STOP_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<PhoneNumber> field5() {
		return Cdr.CDR.CALLED_PHONE_NUMBER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field6() {
		return Cdr.CDR.VOICE_SERVER_NAME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<CallType> field7() {
		return Cdr.CDR.CALL_TYPE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field8() {
		return Cdr.CDR.DIAL_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field9() {
		return Cdr.CDR.ALERT_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<PhoneNumber> field10() {
		return Cdr.CDR.CALLER_PHONE_NUMBER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value2() {
		return getSetupTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value3() {
		return getStartTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value4() {
		return getStopTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public PhoneNumber value5() {
		return getCalledPhoneNumber();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value6() {
		return getVoiceServerName();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CallType value7() {
		return getCallType();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value8() {
		return getDialTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value9() {
		return getAlertTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public PhoneNumber value10() {
		return getCallerPhoneNumber();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value2(Date value) {
		setSetupTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value3(Date value) {
		setStartTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value4(Date value) {
		setStopTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value5(PhoneNumber value) {
		setCalledPhoneNumber(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value6(String value) {
		setVoiceServerName(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value7(CallType value) {
		setCallType(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value8(Date value) {
		setDialTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value9(Date value) {
		setAlertTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord value10(PhoneNumber value) {
		setCallerPhoneNumber(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CdrRecord values(Long value1, Date value2, Date value3, Date value4, PhoneNumber value5, String value6, CallType value7, Date value8, Date value9, PhoneNumber value10) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		value5(value5);
		value6(value6);
		value7(value7);
		value8(value8);
		value9(value9);
		value10(value10);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached CdrRecord
	 */
	public CdrRecord() {
		super(Cdr.CDR);
	}

	/**
	 * Create a detached, initialised CdrRecord
	 */
	public CdrRecord(Long id, Date setupTime, Date startTime, Date stopTime, PhoneNumber calledPhoneNumber, String voiceServerName, CallType callType, Date dialTime, Date alertTime, PhoneNumber callerPhoneNumber) {
		super(Cdr.CDR);

		setValue(0, id);
		setValue(1, setupTime);
		setValue(2, startTime);
		setValue(3, stopTime);
		setValue(4, calledPhoneNumber);
		setValue(5, voiceServerName);
		setValue(6, callType);
		setValue(7, dialTime);
		setValue(8, alertTime);
		setValue(9, callerPhoneNumber);
	}
}
